\
\ Индикатор
\ Модель: ITDB02-3.2WD
\ HX8352

\ DB0-7  -- PC0-7
\ DB8-15 -- PA0-7
\ LCD_RS -- PD7
\ LCD_WR -- PG2
\ LCD_RD -- 3v3
\ LCD_CS -- PG1
\ LCD_RST -- PG0
\ Touch_CLK -- PH3
\ Touch_CS -- PE3
\ Touch_DIN -- PL1
\ Touch_DOUT -- PE5
\ Touch_IRQ -- PE4

marker =tft=
\ &34 constant PORTA	\ Port A Data Register
\ &40 constant PORTC	\ Port C Data Register
\ &43 constant PORTD	\ Port D Data Register-p m2560
\ &52 constant PORTG	\ Data Register, Port G

\ LCD definitions
&400 constant DWIDTH
&240 constant DHEIGHT

PORTD 7 portpin: LCD_RS \ 
PORTG 2 portpin: LCD_WR \ 
PORTG 1 portpin: LCD_CS \ 
PORTG 0 portpin: LCD_RST \ 
\ PORTC $ff portpin: LCD_DL \ 
\ PORTA $ff portpin: LCD_DH \ 

: port:hi ( portadr bitno -- )     \ SBI
   swap [ $20 ] literal - [ 3 ] literal 
lshift or [ $9A00 ] literal or code , end-code
;

: port:lo ( portadr bitno -- )     \ CBI
   swap [ $20 ] literal - [ 3 ] literal 
lshift or [ $9800 ] literal or code , end-code
;

PORTG 2 port:hi wrh
PORTG 2 port:lo wrl
PORTG 1 port:lo csl
PORTG 1 port:lo csh
PORTD 7 port:hi rsh
PORTD 7 port:lo rsl

: hip> [ $ff00 ] literal and [ 8 ] literal rshift ;

only forth also assembler
code lwr-out
$8 R24 out,
$2 R25 out,
end-code

previous

: lcd-write-bus ( nd -- )
\ dup [ $ff ] literal and
\ [ PORTC ] literal c!
\ hip>
\ [ PORTA ] literal c!
 lwr-out drop
wrl wrh
;

: wrtCmd ( n -- )
rsl \ LCD_RS low
lcd-write-bus
;

: wrtData ( n -- )
rsh \ LCD_RS high
lcd-write-bus
;

: lcd-write-comdata ( com data -- )
csl ( LCD_CS low) swap wrtCmd wrtData csh \ LCD_CS high
;

: wrtCmdData ( data com -- )
csl ( LCD_CS low) wrtCmd wrtData csh \ LCD_CS high
;

\ Calculate pixel's color from red, green and blue components
\ Packed color is of the form: rrrrrggggggbbbbb
: pixelColor		( blue green red --- pixelColor)
    >r >r		( blue green red -- blue )
    [ $F8 ] literal and [ 3 ] literal rshift
    r>
    [ $FC ] literal and [ 3 ] literal lshift or
    r>
    [ $F8 ] literal and [ 8 ] literal lshift or
;

variable fgColor
variable bgColor

\ Store foreground color
: setRGBFGColor		( blue green red --- )
    pixelColor fgColor !
;

\ Store background color
: setRGBBGColor		( blue green red --- )
    pixelColor bgColor !
;

\ Store foreground color
: setFGColor		( color --- )
    fgColor !
;

\ Store background color
: setBGColor		( color --- )
    bgColor !
;

\  Сменить ориентацию LCD, портрет/альбом
: lcd-change-direction ( n -- )  \ n = 0 - портретная, 1 - альбомная
csl 
if $bc else $1c then
$16 wrtCmdData
;


\ Set the bounds within the GDDRAM of where to write data
: setBounds 		( x1 y1 x2 y2 --- )

	dup hip> [ $8 ] literal wrtCmdData	\ y2
	[ $ff ] literal and [ $9 ] literal wrtCmdData	

	dup hip> [ $4 ] literal wrtCmdData	\ x2
	[ $ff ] literal and [ $5 ] literal wrtCmdData	

	dup hip> [ $6 ] literal wrtCmdData	\ y1
	[ $ff ] literal and [ $7 ] literal wrtCmdData

	dup hip> [ $2 ] literal wrtCmdData	\ x1
	[ $ff ] literal and [ $3 ] literal wrtCmdData	
    [ $22 ] literal wrtCmd
;

\ Clear the GDDRAM window
: clearBounds	( --- )
    0 0 DWIDTH 1- DHEIGHT 1- setBounds
;


: lcd-init
$ff PORTA 1- c!
$ff PORTC 1- c!
\ LCD_DL pin_output
\ LCD_DH pin_output
LCD_RS pin_output
LCD_RST pin_output
LCD_WR pin_output
LCD_CS pin_output

LCD_CS high
LCD_RS high
LCD_WR high

LCD_RS high
LCD_RST high
5 ms
LCD_RST low
15 ms
LCD_RST high
15 ms



\ LCD_Write_COM(0x83);           

\		LCD_Write_DATA(0x02);  //TESTM=1 
$83 $2 lcd-write-comdata
$85 $3 lcd-write-comdata
$8b $1 lcd-write-comdata
$8c $93 lcd-write-comdata
$91 $1 lcd-write-comdata
$83 $0 lcd-write-comdata
\		//Gamma Setting
$3e $b0 lcd-write-comdata
$3f $3 lcd-write-comdata
$40 $10 lcd-write-comdata
$41 $56 lcd-write-comdata
$42 $13 lcd-write-comdata
$43 $46 lcd-write-comdata
$44 $23 lcd-write-comdata
$45 $76 lcd-write-comdata
$46 $0 lcd-write-comdata
$47 $5e lcd-write-comdata
$48 $4f lcd-write-comdata
$49 $40 lcd-write-comdata
\		//**********Power On sequence************
        
$17 $91 lcd-write-comdata
$2b $f9 lcd-write-comdata

10 ms

$1b $14 lcd-write-comdata
$1a $11 lcd-write-comdata
$1c $6 lcd-write-comdata
$1f $42 lcd-write-comdata       

20 ms
        
$19 $a lcd-write-comdata
$19 $1a lcd-write-comdata

40 ms       
        
$19 $12 lcd-write-comdata

40 ms
        
$1e $27 lcd-write-comdata
100 ms
        
\		//**********DISPLAY ON SETTING***********
        

$24 $60 lcd-write-comdata
$3d $40 lcd-write-comdata
$34 $38 lcd-write-comdata
$35 $38 lcd-write-comdata
$24 $38 lcd-write-comdata

40 ms
        
$24 $3c lcd-write-comdata
$16 $1c lcd-write-comdata
$1 $6 lcd-write-comdata
$55 $0 lcd-write-comdata
$2 $0 lcd-write-comdata
$3 $0 lcd-write-comdata
$4 $0 lcd-write-comdata
$5 $ef lcd-write-comdata
$6 $0 lcd-write-comdata
$7 $0 lcd-write-comdata
$8 $1 lcd-write-comdata
$9 $8f lcd-write-comdata
$22 wrtCmd
1 lcd-change-direction
LCD_CS high
clearBounds
\ Set foreground and background colors to defaults
    255 255 255 pixelColor setFGColor	\ White
      0   0   0 pixelColor setBGColor	\ Black
;

&95 constant SREG	\ Status Register
$80 constant SREG_I \ Global Interrupt Enable
&193 constant UCSR0B	\ USART Control and Status Register B

: int? ( -- f )
   SREG c@ SREG_I and 0>
;

variable saveEmit
variable saveUCSR0B 

\ Obtain exclusive access to all hardware I/O    
: hwAccess[
    \ Turn off serial echo
\    ['] emit defer@ saveEmit ! ['] drop is emit
    \ Interrupts off
\    r> int? >r >r -int
    \ Save uart control register
\    UCSR0B c@ saveUCSR0B c!
    \ Turn off uart output
\    0 UCSR0B c!
    \ Assert chip select
    csl [ $22 ] literal wrtCmd
;

\ Release exclusive access to all hardware I/O    
: ]hwAccess
    \ Deassert chip select
    csh
    \ Restore uart control register
 \   saveUCSR0B c@ UCSR0B c!
    \ Interrupts on
 \   r> r> if +int then >r
    \ Turn serial echo back on
 \   saveEmit @ is emit 
;




\ Fill the LCD screen with foreground color
: fillScn 		(  --- ) 
    \ Obtain exclusive access to all hardware I/O    
    hwAccess[
        clearBounds
csl \ LCD_CS low
[ $22 ] literal wrtCmd
        fgColor @ wrtData
       [ DHEIGHT ] literal [ 0 ] literal do
            [ DWIDTH ] literal [ 0 ] literal do 
\                LCD_WR low
\		[ $f9 ] literal [ PORTG ] literal c!
\                LCD_WR high
		\ [ $fd ] literal [ PORTG ] literal c!
wrl wrh
            loop
        loop 
    \ Release exclusive access to all hardware I/O    
    ]hwAccess
;

\ Clear the screen to background color
: clrScn		( --- )
    fgColor @ >r bgColor @ fgColor !
    fillScn
    r> fgColor !
;


decimal
