\
\ touch1.f
\ ~ilya 
\ 24.01.2014
\ Контроллер: ADS7843/TSC2046
\ Controller: ADS7843/TSC2046
\ Touch_CLK -- PH3
\ Touch_CS -- PE3
\ Touch_DIN -- PL1
\ Touch_DOUT -- PE5
\ Touch_IRQ -- PE4

marker =touch=

\ &46 constant PORTE	\ Data Register, Port E
\ &258 constant PORTH	\ PORT H Data Register
\ &267 constant PORTL	\ PORT L Data Register


PORTH 3 portpin: T_CLK \ 
PORTE 3 portpin: T_CS \ 
PORTL 1 portpin: T_DIN \ 
PORTE 5 portpin: T_OUT \ 
PORTE 4 portpin: T_IRQ \ 

PORTE 3 port:hi t_csh
PORTE 3 port:lo t_csl

&105 constant EICRA	\ External Interrupt Control Register A
&106 constant EICRB	\ External Interrupt Control Register B
&61 constant EIMSK	\ External Interrupt Mask Register
&10  constant INT4Addr \ External Interrupt Request 4


variable temp_x
variable temp_y
variable datacount

\ Посылаем байт в индикатор
\ Submitting byte indicator
: wr-touch ( c -- )
t_csl
&8 0 do
dup i lshift [ $80 ] literal and 
	if T_DIN high 
	else T_DIN low
	then
T_CLK low T_CLK high 
loop
drop
;

\ Принимаем данные (12 бит) из индикатора
\ Receiving data (12 bits) from the indicator
: rd-touch ( -- n )
0
t_csl
&12 0 do
	T_CLK high T_CLK low 
	1 lshift
	T_OUT pin_high? if  1 or then
loop
;

: _read-touch ( c -- n )
wr-touch
T_CLK high T_CLK low 
rd-touch
;

: read-touch
	$90 _read-touch	\ читаем x
	$d0 _read-touch \ читаем y
	dup 1 4095 within  ( x y -- x y fy )
	rot dup 1 4095 within ( x y fy -- y fy x fx )
	rot and if ( temp_x +! temp_y +! ) 1 datacount +!
		else drop drop 0 0 
		then

;

variable touch-x
variable touch-y
variable touch-state	\ Есть реакция от тача	
						\ Any response from the sensor

\ Получаем значение x,y 
\ We get value x,y
: read-touch-xy ( -- x y )
\
0 temp_x ! 0 temp_y ! 0 datacount !
2 0 do
	read-touch temp_x +! temp_y +!
        20 ms
loop
 temp_x @ datacount @ / 	\ усредняем значение x (average value x)
100 1025 */ 400 swap - dup touch-x !
 temp_y @ datacount @ / 	\ усредняем значение y (average value y)
100 1570 */  dup touch-y !
\ 1 touch-state !
;

\ Есть касание ?
\ There are touch ?
: touch? ( -- f )  T_IRQ pin_low? ;

: init-touch
T_IRQ pin_input
T_IRQ pin_pullup_on
T_CS pin_output
T_CLK pin_output
T_OUT pin_input
T_DIN pin_output
t_csl
T_CLK high
T_CLK low
\ [']  isr-t  INT4Addr int! \ 
\ 0 EICRB !			\ Прерывение по спаду
\ $10 EIMSK c@ or EIMSK c!	\ Включаем прерывания от сенсора
;

\ marker =test=
\ : test
\ lcd-init
\ init-touch  +int
\ begin
\ 300 ms
\ read-touch-xy
\ touch?
\ if 
\	read-touch-xy
\ cr . space .
\ 5 1 setXY  s" X: " lcd_typef 7 1 setXY touch-x @ lcd_.
\ 12 1 setXY  s" Y: " lcd_typef 15 1 setXY touch-y @ lcd_.
\ then
\
\ again
\ ;


